<?php
/*
Plugin Name: DD Page Widget
Plugin URI: http://www.divinedeveloper.com/02/07/dd-page-widget-0-1/
Description: Adds a widget that can outputs single page with thumbnail and page excerpt on any widgetized area.
Author: Mladen Milentijevic	
Version: 0.1
Author URI: http://www.divinedeveloper.com/
*/
// Register thumbnail sizes.
if ( function_exists('add_image_size') )
{
	$sizes = get_option('dd_page_post_thumb_sizes');
	if ( $sizes )
	{
		foreach ( $sizes as $id=>$size )
			add_image_size( 'page_thumb_size' . $id, $size[0], $size[1], true );
	}
}
add_action( 'widgets_init', create_function('', 'return register_widget("DD_Page_Widget");') );

class DD_Page_Widget extends WP_Widget {



// Widget construction
function DD_Page_Widget() {
		// Widget settings. */
		$widget_ops = array( 'classname' => 'dd_page_widget', 'description' => __('This widget outputs single page with thumbnail and page excerpt on any widgetized area..', 'dd_page_widget') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'dd_page_widget' );

		/* Create the widget. */
		$this->WP_Widget( 'dd_page_widget', __('DD Page Widget', 'dd_page_widget'), $widget_ops, $control_ops );
	}

//Displaying widget
function widget($args, $instance) {
	global $post;
	extract( $args );

	$sizes = get_option('dd_page_post_thumb_sizes');
	
		if( !$instance["title"] ) {
		$page_name = get_page($instance['page_id']);
		$instance["title"] = $page_name->post_title;
	}
	
	// Excerpt length filter
	$new_excerpt_length = create_function('$length', "return " . $instance["excerpt_length"] . ";");
	if ( $instance["excerpt_length"] > 0 )
		add_filter('excerpt_length', $new_excerpt_length);
		
	$page_id = $instance['page_id'];		

	// Get array of post info.
	$page_posts = new WP_Query("page_id=" . $page_id);
	
	echo $before_widget;
	
	echo $before_title;
	
	// Widget title
		echo '<a href="' . get_page_link($instance['page_id']) . '">' . $instance["title"] . '</a>';
	
	echo $after_title;

    while ( $page_posts->have_posts() )
	{
		$page_posts->the_post();
	?>
			
<?php
		if (
			function_exists('the_post_thumbnail') &&
			current_theme_supports("post-thumbnails") &&
			$instance["thumb"] &&
			has_post_thumbnail()
		) :
	?>
	<?php the_post_thumbnail( 'page_thumb_size'.$this->id ); ?>
			<?php endif; ?>		
    
			<?php if ( $instance['excerpt'] ) : ?>
			<?php the_excerpt(); ?> 
			<?php endif; ?>

	<?php
	}
	
	
	echo $after_widget;
	
}

/**
 * Form processing... Dead simple.
 */
function update($new_instance, $old_instance) {
	/**
	 * Save the thumbnail dimensions outside so we can
	 * register the sizes easily. We have to do this
	 * because the sizes must registered beforehand
	 * in order for WP to hard crop images (this in
	 * turn is because WP only hard crops on upload).
	 * The code inside the widget is executed only when
	 * the widget is shown so we register the sizes
	 * outside of the widget class.
	 */
	if ( function_exists('the_post_thumbnail') )
	{
		$sizes = get_option('dd_page_post_thumb_sizes');
		if ( !$sizes ) $sizes = array();
		$sizes[$this->id] = array($new_instance['thumb_w'], $new_instance['thumb_h']);
		update_option('dd_page_post_thumb_sizes', $sizes);
	}

	return $new_instance;
}

/**
 * The configuration form.
 */
	
function form($instance) {
?>
		<p>
			<label for="<?php echo $this->get_field_id("title"); ?>">
				<?php _e( 'Title' ); ?>:
				<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
			</label>
		</p>

	 	<p>
            <label><?php _e( 'Pages' ); ?>:
            <select name="<?php echo $this->get_field_name('page_id'); ?>">
            <option value=""><?php echo attribute_escape(__('Select page')); ?></option> 
<?php 		//Get list of pages as select options
			$pages = get_pages(); 
  			foreach ($pages as $page) {
  			$option = '<option value="'.$page->ID.'">';
			$option .= $page->post_title;
			$option .= '</option>';
			echo $option;
        // echo '<option value="' . $page->ID . '"' . ($page_id == $page->ID ? ' selected=""' : '') . '>' . $page->post_title . '</option>';
    	} ?>
   			</select>
            </label>
    	</p>
 	
		<p>
			<label for="<?php echo $this->get_field_id("excerpt"); ?>">
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("excerpt"); ?>" name="<?php echo $this->get_field_name("excerpt"); ?>"<?php checked( (bool) $instance["excerpt"], true ); ?> />
				<?php _e( 'Show post excerpt' ); ?>
			</label>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id("excerpt_length"); ?>">
				<?php _e( 'Excerpt length (in words):' ); ?>
			</label>
			<input style="text-align: center;" type="text" id="<?php echo $this->get_field_id("excerpt_length"); ?>" name="<?php echo $this->get_field_name("excerpt_length"); ?>" value="<?php echo $instance["excerpt_length"]; ?>" size="3" />
		</p>
		
		<?php if ( function_exists('the_post_thumbnail') && current_theme_supports("post-thumbnails") ) : ?>
		<p>
			<label for="<?php echo $this->get_field_id("thumb"); ?>">
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("thumb"); ?>" name="<?php echo $this->get_field_name("thumb"); ?>"<?php checked( (bool) $instance["thumb"], true ); ?> />
				<?php _e( 'Show post thumbnail' ); ?>
			</label>
		</p>
		<p>
			<label>
				<?php _e('Thumbnail dimensions'); ?>:<br />
				<label for="<?php echo $this->get_field_id("thumb_w"); ?>">
					W: <input class="widefat" style="width:40%;" type="text" id="<?php echo $this->get_field_id("thumb_w"); ?>" name="<?php echo $this->get_field_name("thumb_w"); ?>" value="<?php echo $instance["thumb_w"]; ?>" />
				</label>
				
				<label for="<?php echo $this->get_field_id("thumb_h"); ?>">
					H: <input class="widefat" style="width:40%;" type="text" id="<?php echo $this->get_field_id("thumb_h"); ?>" name="<?php echo $this->get_field_name("thumb_h"); ?>" value="<?php echo $instance["thumb_h"]; ?>" />
				</label>
			</label>
		</p>
		<?php endif; ?>

<?php

}

}
?>